package bonsai;

/*
 * Class to provide faster access to arrays where d(i,j) == d(j,i)
 * 
 * TODO: Implement as subclass of list instead of hacked Jython-working only-version
 */
public class MetricList {
	
	public static MetricList[] generateList(int n) {
		double data[] = new double[(n*(n+1))/2];
		MetricList ret[] = new MetricList[n];
		for(int i = 0;i<n;i++)
			ret[i] = new MetricList(data,i,n);
		return ret;
	}
	

	double data[];
	int ipos;
	int n;
	public int findPos(int j) {
		//System.out.println(ipos<j?((ipos*(ipos+1))/2) +j:((j*(j+1))/2) +ipos);
		return ipos>j?((ipos*(ipos+1))/2) +j:((j*(j+1))/2) +ipos;
	}
	
	public MetricList(double data[],int ipos,int n) {
		this.data = data;
		this.ipos = ipos;
		this.n = n;
	}
	
	public void __setitem__(int jpos,double val) {
		//System.out.println(ipos + " " + jpos);
		data[findPos(jpos)] = val;
	}
	
	public double __getitem__(int jpos) {
		return data[findPos(jpos)];
	}
	

}
