"""
The hilum package contains several submodules, each containing a class implementing an index structure. (Note that there are also submodules implementing related functionality, such as the TriGen algorithm.)


"""
from glob import glob
import os,os.path
_idxfiles = glob(os.path.join(str(__path__[0]),"*.py"))
idxmodules = [__import__(__name__ + "." + os.path.basename(fname)[:-3],globals(),locals(),[__name__])for fname in _idxfiles if not fname[-5:-3] == "__"]
idxmodules = [m for m in idxmodules if hasattr(m, 'INDEX_NAME')]
usablemods = [x for x in idxmodules if x.USABLE]
knnmods = [x for x in usablemods if hasattr(x,'KNN') and x.KNN]
