"""
The GNAT index structure.
"""

__metaclass__ = type

import pivotselector
import util
from gnat import GNATNode
from approximatedist import IndexingDfunc


class AGNAT:
    def __init__(self,metric,k=10,pivsel=pivotselector.RandomSelector,bucketmethod=None,maxbucket=0):
        self.dfunc = IndexingDfunc(metric.getDistance)
        self.root = GNATNode(metric,self.dfunc,k,pivsel,bucketmethod,maxbucket)
        
    def range_search(self,query,range):
        self.dfunc.startquery(query)
        retlist = self.root.range_search(query,range)
        self.dfunc.stopquery()
        return retlist
    

USABLE = False    
INDEX_NAME = "AGNAT"
INDEX_CLASS = AGNAT
OPTIMIZES_COMBINED_SEARCH = False
BIBTEX_KEYS = "Brin:1995"