"""
The AHC index structure.

This is basically HC with AESA in the nodes. See http://www.cs.uku.fi/~fredriks/pub/papers/prl06.pdf

Should be implemented as a subclass of HC
"""

__metaclass__ = type

from aesa import AESA
from hc import HC
#from approximatedist import IndexingDfunc

class AHC(HC):
    
    def __init__(self,metric,bucketsize=20):
        self.bucketsize = bucketsize
        #self.dfunc = IndexingDfunc(metric.getDistance)
        self.dfunc = metric.getDistance
        self.index(metric)
    
    def bucket(self,glist):
        return AESA(glist)

USABLE = False
INDEX_NAME = "AHC"
INDEX_CLASS = AHC
OPTIMIZES_COMBINED_SEARCH = False
BIBTEX_KEYS = "Fredriksson:2006"
