"""
SSS index structure.
"""

__metaclass__ = type
import util

from ssstree import SSSNode
from approximatedist import IndexingDfunc

class ASSSTree:
    def __init__(self,metric):
        self.metric = metric
        self.dfunc = IndexingDfunc(metric.getDistance,autoadd=False)
        #The first object is the center
        self.root = ASSSNode(self.dfunc,center=self.metric[0])
        for i in xrange(1,len(metric)):
            self.root.add(metric[i])
    
    def range_search(self,query,radius):
        self.dfunc.startquery(query) 
        retlist =  self.root.range_search(query,radius)
        if self.dfunc(query,self.root.center) < radius:
            retlist.append(self.root.center)
        self.dfunc.stopquery()
        return retlist

class ASSSNode(SSSNode):
    def add(self,object):
        self.dfunc.addPoint(object,self.center,self.dfunc(object,self.center))
        super(ASSSNode,self).add(object)
        

USABLE = True
INDEX_NAME = "ASSSTree"
INDEX_CLASS = ASSSTree
OPTIMIZES_COMBINED_SEARCH = False
BIBTEX_KEYS = "Brisboa:2008" # XXX