"""
The EGNAT index structure.
Evolutionary Geometric Near-neighbor Access Tree

http://www.springerlink.com/content/u4056871441386n0/

As GNAT, but does not index small buckets
"""

__metaclass__ = type


from gnat import GNAT
from aesa import AESA

class EGNAT(GNAT):
    def __init__(self,metric,**kwargs):
        super(EGNAT,self).__init__(metric,maxbucket=20,bucketmethod=AESA,**kwargs)

USABLE = True
INDEX_NAME = "EGNAT"
INDEX_CLASS = EGNAT
OPTIMIZES_COMBINED_SEARCH = False
BIBTEX_KEYS = "Uribe:2006"
