package bonsai.indexes;

import java.util.List;


public abstract class AbstractMTree<T> implements MetricIndex<T>{

	protected AbstractMTreeNode<T> root;
	protected DistanceFunction df;
	
	
	protected AbstractMTree(AbstractMTreeNode<T> root, DistanceFunction df){
		this.df = df;
		this.root = root;
	}
	
	@Override
	public List<T> rangeSearch(T o, double r) {
		return root.rangeSearch(o, r);
	}

	
	public void insert(T o){
		AbstractMTreeNode<T> leaf = root.findAccommodatingLeaf(o);
		leaf.insert(o);
		if(leaf.shouldSplit()){
			leaf.split();
			while(root.parent != null) root = root.parent;
		}
	}
	
	public String toString(){
	    return root.toString();
	}
	
}
