package bonsai.indexes;

public class CountingDistanceFunction implements DistanceFunction {

	private boolean isCounting;
	private int count;
	private DistanceFunction df;
	
	public CountingDistanceFunction(DistanceFunction df){
		this.df = df;
	}

	public boolean getIsCounting() {
		return isCounting;
	}

	public void setIsCounting(boolean isCounting) {
		this.isCounting = isCounting;
	}


	public int getCount() {
		return count;
	}
	
	public void resetCounter(){
		count = 0;
	}

	@Override
	public <T> double getDistance(T a, T b) {
		if(isCounting) count++;
		return df.getDistance(a,b);
	}

}
