package bonsai.indexes;

public class LazySlimTree<T> extends AbstractMTree<T> {

	public LazySlimTree(T[] data, DistanceFunction df, int capacity, boolean squaredTime){
		super(new LazySlimTreeNode<T>(df, capacity, squaredTime), df);
		if(df instanceof CountingDistanceFunction){
			((CountingDistanceFunction)df).resetCounter();
		}
		for(T o: data){
			insert(o);		
		}
		((LazySlimTreeNode<T>)root).slimDown();
		if(df instanceof CountingDistanceFunction){
			System.out.println("Counted distance calculations: "+((CountingDistanceFunction)df).getCount());
		}
	}

}
