package bonsai.indexes;

public class SlimTree<T> extends AbstractMTree<T> {
	
	public SlimTree(T[] data, DistanceFunction df, int capacity){
		super(new SlimTreeNode<T>(df, capacity), df);
		if(df instanceof CountingDistanceFunction){
			((CountingDistanceFunction)df).resetCounter();
		}
		for(T o: data){
			insert(o);		
		}
		((SlimTreeNode<T>)root).slimDown();
		if(df instanceof CountingDistanceFunction){
			System.out.println("Counted distance calculations: "+((CountingDistanceFunction)df).getCount());
		}
	}
}
