package bonsai.javaimps;

import java.util.*;

import metrics.core.*;


public class BustosSelector implements PivotSelector {
	
	int samplesize;
	
	public BustosSelector(int samplesize) {
		this.samplesize = samplesize;
	}


	public List<MetricObject> getPivots(MetricList m, int numpivots) {
		
		List<MetricObject> objects = new ArrayList<MetricObject>(m);
		
		
		List<MetricObject> qas = PivotSelectorHelper.getRandomObjects(objects, samplesize);
		List<MetricObject> qbs = PivotSelectorHelper.getRandomObjects(objects, samplesize);
		
		List<MetricObject> pivots = new ArrayList<MetricObject>();
		
		double lowlist[] = new double[m.size()];
		
		for(int i = 0;i<numpivots;i++) {
			
			List<MetricObject> pivotposs = PivotSelectorHelper.getRandomObjects(objects, samplesize);
			
			double bestval = 0;
			MetricObject bestPivot = null;
			
			for(MetricObject p:pivotposs) {
				double sum = 0;
				for(int j = 0;j<qas.size();j++) {
					sum += Math.max(lowlist[j],Math.abs(m.getDistance(p,qas.get(j))-m.getDistance(p,qbs.get(j))));
				}
				if(sum >= bestval) {
					bestval = sum;
					bestPivot = p;
				}
			}
			objects.remove(bestPivot);
			//System.out.println(bestval);
			for(int j = 0;j<qas.size();j++) {
				//System.out.println(bestPivot);
				//System.out.println(qas.get(j));
				//System.out.println(qbs.get(j));
				
				lowlist[j] = Math.max(lowlist[j],Math.abs(m.getDistance(bestPivot,qas.get(j))-m.getDistance(bestPivot,qbs.get(j))));
			}
			pivots.add(bestPivot);
		}
		
		return pivots;
	}

	

}
