"""
The Slim-Tree index structure, augmented by calculating the MST-part of it lazily
"""

__metaclass__ = type

USABLE = True
try:
    from bonsai.indexes import LazySlimTree as JLazySlimTree
    from java.lang import Object
    from jarray import array
except:
    USABLE = False

import util


class LazySlimTree:
    
    
    def __init__(self, metric, capacity=32, squaredTime = False):
        self.lazyslimtree = JLazySlimTree(array(list(metric), Object), util.getCountingDistanceFunction(metric.getDistance), capacity, squaredTime)
        
    def range_search(self, query, radius):
        return self.lazyslimtree.rangeSearch(query, radius)

INDEX_NAME = "Slim-Tree (Lazy)"
INDEX_CLASS = LazySlimTree
OPTIMIZES_COMBINED_SEARCH = False
BIBTEX_KEYS = "Traina:2000,Skopal:2003" # XXX