"""
The Linear Scan index structure.
"""

__metaclass__ = type

class LinearScan:
    
    def __init__(self, metriclist):
        self.data = metriclist
        self.dfunc = metriclist.getDistance
    
    def range_search(self, query, range):
        return self.search(query, range=range)
    
    def knn_search(self,query,count):
        return self.search(query,count=count)
    
    def search(self, query, range=None, count=None):
        if range is None and count is None:
            count = 1
       
        cmped = [(self.dfunc(query, o), o) for o in self.data]
        cmped.sort()
        if count is not None:
            cmped = cmped[:count]
        if range is not None:
            cmped = [(d, o) for (d, o) in cmped if d <= range]
        return [o for (d, o) in cmped]

USABLE = True
INDEX_NAME = "Linear Scan"
INDEX_CLASS = LinearScan
OPTIMIZES_COMBINED_SEARCH = True
BIBTEX_KEYS = "Beyer:1999"