"""
The M*-Tree, an M-tree augmented with Nearest-Neighbor Graphs.
"""

__metaclass__ = type

USABLE = True
try:
    from bonsai.indexes import MStarTree as JMStarTree
    from java.lang import Object
    from jarray import array
except e:
    USABLE = False

import util


class MStarTree:    
    def __init__(self, metric, capacity=32):
        self.pmtree = JMStarTree(array(list(metric), Object), util.JavaDistanceFunction(metric.getDistance), capacity)
        
    def range_search(self, query, radius):
        return self.pmtree.rangeSearch(query, radius)

INDEX_NAME = "M*-Tree"
INDEX_CLASS = MStarTree
OPTIMIZES_COMBINED_SEARCH = False
BIBTEX_KEYS = "Skopal:2007a"