"""
The M-Tree index structure.
"""

__metaclass__ = type

USABLE = True
try:
    from bonsai.indexes import MTree as JMTree
    from java.lang import Object
    from jarray import array
except:
    USABLE = False

import util


class MTree:
    
    
    def __init__(self, metric, capacity=32):
        #metric.getDistance
        #array(metric, Object)
        #util.JavaDistanceFunction(metric.getDistance)
        self.mtree = JMTree(array(list(metric), Object), util.JavaDistanceFunction(metric.getDistance), capacity)
        
    def range_search(self, query, radius):
        #return []
        return self.mtree.rangeSearch(query, radius)


INDEX_NAME = "M-Tree"
INDEX_CLASS = MTree
OPTIMIZES_COMBINED_SEARCH = False
BIBTEX_KEYS = "Zezula:1996,Ciaccia:1997,Ciaccia:1997a,Ciaccia:1998" # XXX