"""
The PM*-Tree, a PM-tree augmented with Nearest-Neighbor Graphs.
"""

__metaclass__ = type

USABLE = True
try:
    from bonsai.indexes import PMStarTree as JPMStarTree
    from java.lang import Object
    from jarray import array
except e:
    USABLE = False

import util


class PMStarTree:
    
    
    def __init__(self, metric, capacity=32, nPivots=20, bustos = True):
        self.pmtree = JPMStarTree(array(list(metric), Object), util.JavaDistanceFunction(metric.getDistance), capacity, nPivots, bustos)
        
    def range_search(self, query, radius):
        return self.pmtree.rangeSearch(query, radius)

INDEX_NAME = "PM*-Tree"
INDEX_CLASS = PMStarTree
OPTIMIZES_COMBINED_SEARCH = False
BIBTEX_KEYS = "Skopal:2007a"