"""
The PM-Tree index structure.
"""

__metaclass__ = type

USABLE = True
try:
    from bonsai.indexes import PMTree as JPMTree
    from java.lang import Object
    from jarray import array
except e:
    USABLE = False

import util


class PMTree:
    
    
    def __init__(self, metric, capacity=32, nPivots=20, bustos = True):
        self.pmtree = JPMTree(array(list(metric), Object), util.JavaDistanceFunction(metric.getDistance), capacity, nPivots, bustos)
        
    def range_search(self, query, radius):
        return self.pmtree.rangeSearch(query, radius)

INDEX_NAME = "PM-Tree"
INDEX_CLASS = PMTree
OPTIMIZES_COMBINED_SEARCH = False
BIBTEX_KEYS = "Skopal:2004a"