"""
The Slim-Tree index structure.
"""

__metaclass__ = type

USABLE = True
try:
    from bonsai.indexes import SlimTree as JSlimTree
    from java.lang import Object
    from jarray import array
except:
    USABLE = False

import util


class SlimTree:
    
    
    def __init__(self, metric, capacity=32):
        self.slimtree = JSlimTree(array(list(metric), Object), util.getCountingDistanceFunction(metric.getDistance), capacity)
        
    def range_search(self, query, radius):
        return self.slimtree.rangeSearch(query, radius)

INDEX_NAME = "Slim-Tree"
INDEX_CLASS = SlimTree
OPTIMIZES_COMBINED_SEARCH = False
BIBTEX_KEYS = "Traina:2000,Skopal:2003" # XXX