package bonsai.test;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;
import java.util.Random;

import bonsai.indexes.DistanceFunction;
import bonsai.indexes.LazySlimTree;

import bonsai.indexes.*;
public class Test {
	
	
	public Test(Object o){
		System.out.println("new Test()");
	}
	
	public Object[] test(Object[] ar){
		System.out.println("Test.test(ar)");
		return ar;
	}
	
	static Random rnd = new Random(12234132);
	
	static int cnt;
	public static void main(String[] args){
	    Integer[] data = new Integer[10000];
	    for(int i = 0; i < data.length; i++){
	        data[i] = i;
	    }
	    List<Integer> list = Arrays.asList(data);
	    Collections.shuffle(list, rnd);
	    data = list.toArray(data);
	    DistanceFunction df = new DistanceFunction(){
	        public double getDistance(Object a, Object b){
	            cnt++;
	            return Math.abs(((Integer)a)-((Integer)b));
	        }
	    };
	    long time = System.currentTimeMillis();
//	    SlimTree<Integer> mtree = new SlimTree<Integer>(data, df, 32);
	    PMStarTree<Integer> mtree = new PMStarTree<Integer>(data, df, 5,20,true);
	    //LazySlimTree<Integer> mtree = new LazySlimTree<Integer>(data, df, 32);
	    //PMTree<Integer> mtree = new PMTree<Integer>(data, df, 32, 20);
	    //MTree<Integer> mtree = new MTree<Integer>(data, df, 32);
	    System.out.println("Indexing: "+cnt);
	    cnt = 0;
	   // System.out.println(mtree);
	    for(int i = 0; i < data.length; i++){
	    	if(mtree.rangeSearch(i,0).size() != 1){
	    		System.out.println(i+"!!");
	    		break;
	    	}
	    }
	    //List<Integer> res = mtree.rangeSearch(2,0);
	    //Collections.sort(res);
	    //System.out.println(res);
	    //System.out.println(res.size());
	    System.out.println("Searching: "+cnt);
	    System.out.printf("Time taken: %dms%n",System.currentTimeMillis()-time);
	}
	
	
	
	
	
}
