"""
The Voronoi-Tree index structure.
"""

import bstree
from sets import Set as set

__metaclass__ = type

class VoronoiTree(bstree.BSTree):

    pivot_count = 3

    def new_child_hook(self, parent, child, idx):
        # Add the existing pivot closest to the new one, from the
        # parent node.
        closest = parent.pivots[idx]
        child.pivots.append(closest)
        dups = child.setdefault('dups', set())
        dups.add(id(closest))

USABLE = True
INDEX_NAME = "Voronoi-Tree"
INDEX_CLASS = VoronoiTree
OPTIMIZES_COMBINED_SEARCH = False
BIBTEX_KEYS = "Dehne:1987" # Noltemeier:1989
