#!/usr/bin/env python

"""
Simple (temporary) script to generate a list of methods implemented.
"""

from __future__ import division

from glob import *
import os, sys
sys.path.insert(0, '../bonsai')

fnames = glob('../bonsai/*.py')
mnames = [os.path.basename(n)[:-3] for n in fnames]
modules = [__import__(n) for n in mnames]

template = '%-20s %4s %48s'

print '='*74
print template % ('Name', 'Done', 'References')
print '-'*74

count = 0
donecount = 0

for module in modules:
    count += 1
    if not hasattr(module, 'INDEX_CLASS'):
        continue
    if module.USABLE:
        donecount +=1
        usable = '+ '
    else:
        usable = '- '
    print template % (module.INDEX_NAME, usable, module.BIBTEX_KEYS)

print '-'*74
print 'Done: %i%%' % (donecount/count*100,)
print '='*74