/*
 * ImageSearch.java
 *
 * Created on April 21, 2008, 5:28 PM
 */

package gui;

import bonsai.javaimps.*;
import metrics.core.*;
import metrics.*;
import javax.swing.JFileChooser;
import java.io.*;
import java.util.*;
import javax.swing.ImageIcon;
import javax.swing.table.AbstractTableModel;
import javax.swing.table.DefaultTableModel;

/**
 *
 * @author  arnebef
 */
public class ImageSearch extends javax.swing.JFrame {
    
    public LAESA laesa = null;
    final static int dims[] = {6,12,12,3,3};
    final static float posweight = 0.5f;
    public QuadraticForm qf;
    public GenericMetricList<QuadraticFormImageMetric> ml;
    
    /** Creates new form ImageSearch */
    public ImageSearch() {
        initComponents();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    @SuppressWarnings("serial")
	private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        resultTable = new javax.swing.JTable();
        indexButton = new javax.swing.JButton();
        queryButton = new javax.swing.JButton();
        saveButton = new javax.swing.JButton();
        loadButton = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        resultTable.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "Result", "Image", "Distance"
            }
        ) {
            Class<?>[] types = new Class [] {
                java.lang.Integer.class, java.lang.Object.class, java.lang.Double.class
            };
            boolean[] canEdit = new boolean [] {
                false, false, false
            };

            public Class<?> getColumnClass(int columnIndex) {
                return types [columnIndex];
            }

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        resultTable.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_ALL_COLUMNS);
        resultTable.setRowHeight(100);
        jScrollPane1.setViewportView(resultTable);

        indexButton.setText("Index...");
        indexButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                indexButtonActionPerformed(evt);
            }
        });

        queryButton.setText("Query...");
        queryButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                queryButtonActionPerformed(evt);
            }
        });

        saveButton.setText("Save...");
        saveButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                saveButtonActionPerformed(evt);
            }
        });

        loadButton.setText("Load...");
        loadButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                loadButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addComponent(saveButton)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(loadButton)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 165, Short.MAX_VALUE)
                .addComponent(indexButton)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(queryButton))
            .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 400, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(queryButton)
                    .addComponent(indexButton)
                    .addComponent(saveButton)
                    .addComponent(loadButton))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 275, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void queryButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_queryButtonActionPerformed
        if(laesa == null)
            return;
        JFileChooser jf = new JFileChooser();
        int retval = jf.showOpenDialog(this);
        if(retval == jf.APPROVE_OPTION) {
            File image = jf.getSelectedFile();
            try {
            QuadraticFormImageMetric query = new QuadraticFormImageMetric(image.getAbsolutePath(),qf);
            ml.reset();
            List list = laesa.knn_search(query,10);
            System.out.println(ml.getDistCount());
            
            ArrayList<Object[]> displist = new ArrayList<Object[]>();
            displist.add(new Object[]{new Integer(0),new ImageIcon(ImageMetricHelper.getImage(query.getPath())),new Double(0.0)});
            for(int i = 0;i<list.size();i++) {
                QuadraticFormImageMetric qfim = (QuadraticFormImageMetric) list.get(i);
                System.out.println(qfim.getPath());
                displist.add(new Object[]{new Integer(i+1),
                        new ImageIcon(ImageMetricHelper.getImage(qfim.getPath())),
                        new Double(qfim.getDistance(query))});
            }
            
            final String column[] = {"Result","Image","Distance"};
            final Class<?>  colclass[] = {Integer.class,ImageIcon.class,Double.class};
            
            @SuppressWarnings("serial")
			class ResultTableModel extends AbstractTableModel {
                ArrayList<Object[]> displist;
                public ResultTableModel(ArrayList<Object[]> displist) {
                    this.displist = displist;
                }
                public int getColumnCount() { return column.length; }
                public int getRowCount()    { return displist.size(); }
                public String getColumnName(int col) {
                    return column[col];
                }
                public Object getValueAt(int row, int col) { 
                    return displist.get(row)[col];
                }
                
                public Class<?> getColumnClass(int col) {
                    return colclass[col];
                }
            };
         
            
            ResultTableModel model = new ResultTableModel(displist);

            resultTable.setAutoCreateRowSorter(true);
            resultTable.setModel(model);
            
            } catch(Exception e) {
                e.printStackTrace();
                return;
            }
            
            
            
        }
        
}//GEN-LAST:event_queryButtonActionPerformed

    private void indexButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_indexButtonActionPerformed
        // TODO addur handling code here:
        JFileChooser jf = new JFileChooser();
        jf.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
        int retval = jf.showOpenDialog(this);
        if(retval == jf.APPROVE_OPTION) {
            File dir = jf.getSelectedFile();

            QuadraticFormImageGenerator qfig = new QuadraticFormImageGenerator(dir.getPath(),dims,posweight);
            this.qf = qfig.getQf();
            ml = new GenericMetricList<QuadraticFormImageMetric>(qfig);
            ml.generateData(1000);
            ml.reset();
            
            long nlen = 0;
            for(QuadraticFormImageMetric im:ml) {
            	nlen += im.getData().indices.length;
            }
            System.out.println((1.0*nlen)/ml.size());
            
            qfig.getQf().resetCallcount();
            long before = System.currentTimeMillis();
            laesa = new LAESA(ml,20,new BustosSelector(50));
            
            
            System.out.println(ml.getDistCount());
            System.out.println((1.0*System.currentTimeMillis()-before)/qfig.getQf().getCallcount());
        }
}//GEN-LAST:event_indexButtonActionPerformed

    private void saveButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_saveButtonActionPerformed
        JFileChooser jf = new JFileChooser();
        int retval = jf.showOpenDialog(this);
        if(retval ==jf.APPROVE_OPTION) {
            File file = jf.getSelectedFile();
            try {
                ObjectOutputStream stream = new ObjectOutputStream(new FileOutputStream(file));
                stream.writeObject(ml);
                stream.writeObject(laesa);
                stream.writeObject(qf);
                stream.close();
            }
            catch(Exception e) {
                e.printStackTrace();
            }
        }
    }//GEN-LAST:event_saveButtonActionPerformed

    private void loadButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_loadButtonActionPerformed
        JFileChooser jf = new JFileChooser();
        int retval = jf.showOpenDialog(this);
        if(retval ==JFileChooser.APPROVE_OPTION) {
            File file = jf.getSelectedFile();
            try {
                ObjectInputStream stream = new ObjectInputStream(new FileInputStream(file));
                ml = (GenericMetricList<QuadraticFormImageMetric>) stream.readObject();
                laesa = (LAESA) stream.readObject();
                qf = (QuadraticForm) stream.readObject();
                stream.close();
            }
            catch(Exception e) {
                e.printStackTrace();
            }
        }
    }//GEN-LAST:event_loadButtonActionPerformed
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new ImageSearch().setVisible(true);
            }
        });
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton indexButton;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JButton loadButton;
    private javax.swing.JButton queryButton;
    private javax.swing.JTable resultTable;
    private javax.swing.JButton saveButton;
    // End of variables declaration//GEN-END:variables
    
}
