package metrics;

import java.util.ArrayList;
import java.io.*;
import java.rmi.server.UID;
import metrics.core.*;

public class EditDistance implements MetricObject<char[]> {
	

	private char[] data;
	
	final static int inscost = 1;
	final static int delcost = 1;
	final static int changecost = 1;
	
	static int next[] = new int[1];
	static int last[] = new int[1];
	static int t[] = new int[0];
	
	public EditDistance(String data) {
		this.data = data.toCharArray();
	}
	
	/**
	 * Computes the editdistance with cost = 1
	 */
	public double getDistance(MetricObject<char[]> other) {
		char[] a = data;
		char[] b= other.getData();
		int alen = a.length;
		int blen = b.length;
		if(data.length+1 > next.length) {
			next = new int[data.length+1];
			last = new int[data.length+1];
			t = new int[data.length];
		}
		
		for(int i = 0;i<=alen;i++)
			last[i] = i;
		
		
		for(int i = 1;i<=blen;i++) {
			
			next[0] = i;
			//System.out.print(next[0] +  " ");
			for(int j = 1;j<=alen;j++) {
				next[j] = Math.min(
						last[j]+inscost,
						Math.min(
							next[j-1]+delcost,
							last[j-1]+(b[i-1] == a[j-1]?0:changecost)
						)
				);
				//System.out.print(next[j] + " ");
			
			}
			//System.out.println();
			t = last;
			last = next;
			next = t;
		}
		return last[alen];
	}

	public char[] getData() {
		return data;
	}

	public Object getUid() {
		return data;
	}

	public void setData(char[] data) {
		this.data = data;
	}
	
	public String toString() {
		return new String(data);
	}
	
	public static void main(String args[]) {
		
		EditDistance ed1 = new EditDistance("and night shall be no more  and they shall not need the light of the lamp nor the light of the sun because the lord god shall enlighten then  and they shall reign for ever and ever");
		EditDistance ed2 = new EditDistance("and he said to me  these words are most faithful and true  and the lord god of the spirits of the prophets sent his angel to shew his servant the things which must be done shortly");
		System.out.println(ed1.getDistance(ed2));
		
		
	}
	

}
