package metrics;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.Random;

import metrics.core.RandomGeneratedMetric;

public class EditDistanceGenerator implements RandomGeneratedMetric<EditDistance> {
	
	String wordfile;

	public EditDistanceGenerator(String wordfile) {
		this.wordfile = wordfile;
	}
	/**
	 * TODO: Make this function random (only returns first n strings atm)
	 */
	
	
	
	public List<EditDistance> generateRandomObjects(int amount,long seed) {
		ArrayList<EditDistance> retlist = new ArrayList<EditDistance>();
		try {
			BufferedReader br = new BufferedReader(new FileReader(wordfile));
			String line;
			int count = 0;
			Random random = new Random(seed);
			while((line = br.readLine()) != null) {
				int rint = count > 0 ? random.nextInt(count) : 0;
				if(rint < amount) {
					EditDistance ed = new EditDistance(line);
					if(count < amount) {
						retlist.add(ed);
					} else {
						retlist.set(rint,ed);
					}
				}
				count++;
			}
			
		} catch(IOException e) {
			System.out.println("Could not get amount of strings needed because of IOException");
			System.out.println("Error: " + e.toString());
		}
		return retlist;
		
	}


}
