package metrics;
import java.util.ArrayList;
import java.rmi.server.UID;
import metrics.core.RandomGeneratedMetric;
import metrics.core.MetricObject;

public class Euclidian implements MetricObject<double[]>{
	/**
	 * 
	 */
	private static final long serialVersionUID = 5760524886188845359L;
	
	int lp;
	public double data[];
	UID uid;
	
	public Euclidian(double data[]) {
		this(data,2);
	}
	public Euclidian(double data[],int lp) {
		this.data = data;
		this.lp = lp;
		this.uid = new UID();
	}
	
	public double getDistance(MetricObject<double[]> other) {
		
		double sum = 0;
		double otherd[] = other.getData();
		for(int i = 0;i<data.length;i++) {
			sum += Math.abs(Math.pow(data[i]-otherd[i],lp));
		}
		return Math.pow(sum,1.0/lp);
		
	}
	public UID getUid() {
		return uid;
	}
	public double[] getData() {
		return data;
	}
	public void setData(double[] data) {
		this.data = data;
		
	}
	

}
