package metrics;

import java.util.ArrayList;
import java.util.List;
import java.util.Random;

import metrics.core.RandomGeneratedMetric;

public class EuclidianGenerator implements RandomGeneratedMetric<Euclidian> {

	int lp;
	int dimensions;
	public EuclidianGenerator() {
		this(10);
		
	}
	public EuclidianGenerator(int dimensions) {
		this(dimensions,2);
	}
	
	public EuclidianGenerator(int dimensions,int lp) {
		this.dimensions = dimensions;
		this.lp = lp;
	}
	
	public List<Euclidian> generateRandomObjects(int amount,long seed) {
		ArrayList<Euclidian>ret = new ArrayList<Euclidian>();
		Random random = new Random(seed);
		for (int i =0;i<amount;i++) {
			double next[] = new double[this.dimensions];
			for(int j = 0;j<this.dimensions;j++) {
				next[j] = random.nextDouble();
			}
			ret.add(new Euclidian(next));
		}
		return ret;
	}

}
