package metrics;
import java.awt.image.BufferedImage;
import java.io.IOException;
import java.io.Serializable;
import java.rmi.server.UID;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.io.File;
import metrics.core.*;

public class QuadraticFormImageMetric implements MetricObject<QuadraticForm.QFData>{
	
	String path;
	QuadraticForm.QFData data;
	QuadraticForm qf;
	UID uid;
	
	
	public QuadraticFormImageMetric(String path,QuadraticForm qf) throws IOException {
		this.path = path;
        BufferedImage image = ImageMetricHelper.getImage(path);
		this.setData(qf.genNormalizedHist(ImageMetricHelper.toCIELABXY(image)));
		this.qf = qf;
		//System.out.println(path + " added");
		uid = new UID();
	}
	
	public QuadraticForm.QFData getData() {
		return data;
	}

	public double getDistance(MetricObject<QuadraticForm.QFData> other) {
		return qf.getDistance(data,other.getData());
	}

	public Object getUid() {
		return uid;
	}
	
	public void setData(QuadraticForm.QFData data) {
		this.data = data;
		
	}

	public String getPath() {
		return path;
	}

	public void setPath(String path) {
		this.path = path;
	}
	
	public String toString() {
		return this.path;
	}
	
	public static void main(String[] args) throws IOException{
		int dims[] = {4,8,8,3,3};
		float mins[] = {0,-100,-100,0,0};
		float maxs[] = {100,100,100,100,100};
		float weights[] = {1.0f,1.0f,1.0f,0.5f,0.5f};      
		QuadraticForm qf = new QuadraticForm(dims,mins,maxs,weights);
		QuadraticFormImageMetric qfa = new QuadraticFormImageMetric("bonsai/src/metrics/images/436.jpg",qf);
		QuadraticFormImageMetric qfb = new QuadraticFormImageMetric("bonsai/src/metrics/images/532.jpg",qf);
		System.out.println(qfa.getDistance(qfb));
		
	}
	
}
