package metrics.core;


import java.io.Serializable;

/*
 * A metric is mathematically defined as a tuple (distance function,data). The same applies
 * for implementations of this Java Class
 * 
 * A simple abstract implementation that can be used is AbstractMetricList, but this has
 * the limitation that the objects (and the object structure) has to be in memory. Another
 * implementation could use e.g. an IO-based structure.
 * 
 * 
 */
public interface MetricObject<T> extends Serializable{
	public void setData(T data);
	public T getData();
	/**
	 * This should be an unique identifier for the object, e.g. for a file it could be the path
	 * This is to have a distance cache lookup, without having to have the whole object in memory.
	 * The identifier must be unique for each object (can use java.rmi.server.UID or a counting singelton)
	 */
	public Object getUid();
	public double getDistance(MetricObject<T> other);
	
}
