import random
import math
from metric import Metric
import os.path
#import editdist

def randomsample(alist,n):
    count = 0
    retlist = list(alist)[:n]
    for i in alist:
        pos = random.randint(0,count)
        if pos < n:
            retlist[pos] = i
        count += 1

    return retlist
        

class Levensthein(Metric):
    
    def __init__(self,filename=os.path.join(os.path.dirname(__file__),"listofwords.txt")):
        self.filename = filename

    def generateDfunc(self):
    

        #_d = [[x + y for x in xrange(0,100)] for y in xrange(0,100)]
        def dfunc(s,t):
            m, n = len(s), len(t)
            d = [[x + y for x in xrange(0,n+1)] for y in xrange(0,m+1)]
            #Optimize function lookup
            dmin = min
            #d = _d
            for i in xrange(1,m+1):
                for j in xrange(1,n+1):
                    cost = 1
                    if s[i-1] == t[j-1]:
                        cost = 0
                    d[i][j] = dmin(d[i][j-1]+1,d[i-1][j]+1,d[i-1][j-1]+cost)
            return d[m][n]
        return dfunc

    def generateData(self,size=1000):
        self.tdata = file(self.filename).readlines()
        print size
        if size == -1:
            size = len(self.tdata)
        if size > len(self.tdata):
            size = len(self.tdata)
        self.data = [self.tdata[x].strip() for x in randomsample(xrange(len(self.tdata)),size)]
       
        #Used to generate random queries
        #Find average length
        avg = 0
        for word in self.tdata:
            avg += len(word)
        self.avg = 1.0*avg/len(self.tdata)

        #Find variance
        var = 0
        for word in self.tdata:
            var += (len(word) -avg)**2
        self.var = math.sqrt(var/len(self.tdata))
 

    def generateRandomQueries(self,num=1,intext=True):
        if not hasattr(self,'data'):
            raise Exception("Metric not initalized")
        if intext:
            return [self.tdata[x].strip() for x in 
                        randomsample(xrange(len(self.tdata)),num)]
        else:
            alphabet = "abcdefghijklmnopqrstuvwxyz"
            queries = []
            for i in xrange(num):
                wordlen = int(abs(random.gauss(self.avg,self.var)))
                s = ""
                for j in xrange(wordlen):
                    s += alphabet[random.randint(len(alphabet))]
                queries.append(S)
            return queries
                
if __name__=="__main__":
    import time
    leven = Levensthein()
    d = leven.generateDfunc() 
    t = time.time()
    [d("asdfsadasdfsadasdfffasdfasdfasdf","asdfasdfasdf") for x in xrange(1000)]
    print d("sanf","sann")
    print time.time() -t 



          
        







    
