#!/usr/bin/env python
import os,os.path,sys,math
import random
import traceback
from glob import glob
from bonsai import mtree2

#import psyco
#psyco.full()

#Since there already is a module called test,
#we have to put . first in the path
#TODO:
#This is a bit hackish
#Should find a better way to do this
sys.path.insert(0, '..')
import metrics
sys.path.insert(0, '.')
import test
print metrics

class CallCounter(object):
    
    counter = 0

    def __init__(self,dist):
        self.dist = dist
        self.reset()
        
    def __call__(self,x,y):
        self.counter += 1
        return self.dist(x,y)

    def reset(self):
        t = self.counter
        self.counter = 0
        return t
class Bencher(object):

    def __init__(self,metric,modules,modargs=False,size=1000,range=None,debug=False,generateData=True,**kwargs):
        self.metric = metric 
        self.modules = modules # Lets not screw up the original list
        self.modargs = modargs
        self.debug = debug
        if generateData:
            self.metric.generateData(int(size))

    def bench_range_search(self,range=1,randomqueries=20):
        d = CallCounter(self.metric.generateDfunc())
        queries = self.metric.generateRandomQueries(randomqueries)
        #queries.extend(self.metric.generateRandomQueries(randomqueries))
        r = range
        vals = []
        for m in self.modules:
            try:
                margs = {}
                if self.modargs:
                    (m,margs) = m
                dict = {}
                dict['name'] = m.INDEX_NAME
                if self.modargs:
                    dict['args'] = margs 
                d.reset()
                print "Indexing %s" % m.INDEX_NAME,
                sys.stdout.flush()
                print margs
                instance = m.INDEX_CLASS(self.metric.data,d,**margs)
                print "%d distance lookups" % d.counter
                dict['indexcount'] = d.reset()
                
                print "Querying %s (%d queries)" % (m.INDEX_NAME,len(queries)),
                sys.stdout.flush()
                discounts = 0
                nn = len(queries)
                qresults = map(instance.range_search,queries,[r]*nn)
                
                #for q in queries:
                    #if self.debug : print "%s: Performing query %s" % (m.INDEX_NAME,str(q))
                #    instance.range_search(q,r)
                    #if self.debug: 
                    #    print "%s: Result: %s" % (m.INDEX_NAME,str(res))
                    #    print "Used %d distance lookups" % d.counter
                    #discounts += d.reset()
                discounts = d.reset()
                print "%d distance lookups" % discounts
                print "%.2f%% of entries returned on average" % (sum([len(qr)/float(len(self.metric.data)) for qr in qresults])*100.0/nn)
                dict['querycount'] = discounts
                vals.append(dict)
            except Exception,e:
                print "Error in %s: %s" %(m.INDEX_NAME,str(e))
                traceback.print_exc()
                dict = {'name':m.INDEX_NAME,'error':-1}
                vals.append(dict)
        return vals

if __name__=="__main__":
    #Test all methods
    usablemods = [m for m in test.idxmodules if getattr(m,'USABLE',True)]
    nonsqrmods = [m for m in usablemods if not getattr(m,'SQUARED_MEM',False)]
    #ecbench = EuclidianBencher(usablemods)
    #print ecbench.bench_range_search()
    print dir(metrics)
    
    

    #lcmet = metrics.Levensthein()
    lcmet = metrics.Euclidian(30)
    lcmet.generateData(1000)

    lcbench = Bencher(lcmet,nonsqrmods,generateData=False)
    #lcbench = Bencher(lcmet,mtreemods,generateData=False,modargs=True)
    #queries = lcmet.generateRandomQueries(100)

    for r in [2.0]:
        print "With range %.2f" % r
        results = lcbench.bench_range_search(r,10)
        for result in results:
            s = "Name: "+result['name']
            for (pretty, act) in zip(["Args","Index cost","Query cost"],['args','indexcount','querycount']):
                if result.has_key(act):
                    s += ", "+pretty+": "+str(result[act])                
            print s
                                                      
