import os
from metrics import clusteredEuclidian,euclidian,editDistance,imageMetric

metlist = [("ClusteredEuclidian",clusteredEuclidian),("Euclidian",euclidian),("Edit-distance",editDistance),("QFD",imageMetric)]
size = 100
nbins = 100


for name,met in metlist:
    fd = file("%s.plot"%name,"w")
    fd.write("set xlabel \"%s\"\n"%name)
    fd.write("set ylabel \"Distance\"\n")
    fd.write("set key off\n")
    
    distlist = []
    metric = met()
    metric.generateData(size)
    for i in metric:
        for j in metric:
            if i != j:
                distlist.append(metric.getDistance(i,j))
                
    
    dmax = max(distlist)
    
    fd.write("plot [%d:%d] '%s.dat' with boxes lw 2\n"%(0,dmax,name))
    fd.close()
    

    bins = [0]*nbins
    for dist in distlist:
        t = int(dist/dmax*(nbins-1))
        bins[t] += 1
    
    fp = file("%s.dat"%name,"w")
    for i,bin in enumerate(bins):
        fp.write("%f %d %s"%((dmax*i)/(nbins-1),bin,os.linesep))
        
    
    
    
    
    
                
                
    
