#!python
import time
import os
import metrics
#rint dir(metrics)
import random
from ConfigParser import ConfigParser

def my_import(name):
    mod = __import__(name)
    components = name.split('.')
    for comp in components[1:]:
        mod = getattr(mod, comp)
    return mod



    


class Benchmark(object):
    
    def __init__(self,config):
        self.config = config
        
        margs = eval(config.get("Bonsai","metricargs"))
        
        self.metric = eval("metrics.%s(*margs)"%config.get("Bonsai","metric"))
        self.modlist = []
        for module in eval(config.get("Bonsai","modlist")):
            self.modlist.append(my_import("bonsai.%s"%module))

        if config.has_option("Bonsai","modargs"):
            print config.get("Bonsai","modargs")
            self.modargs = eval(config.get("Bonsai","modargs"))
            print self.modargs
        else:
            self.modargs = [[]]*len(self.modlist)
        
    def run(self):
        #Find the current timestamp
        cf = self.config
        pindex = cf.getboolean("Bonsai","printindexcount")
        pquery = cf.getboolean("Bonsai","printquerycount")
        nqueries = cf.getint("Bonsai","nqueries")
        dataset = cf.getint("Bonsai","dataset")
        querytrim = cf.getint("Bonsai","querytrim")
        indextrim = cf.getint("Bonsai","indextrim")
        fname = ""
        if cf.has_option("Bonsai","name"):
            fname += cf.get("Bonsai","name")+ "-"
        fname += time.strftime("%m%d-%H%M%S")
        #fname = time.strftime("%m%d-%H%M%S")
        outputdir = cf.get("Bonsai","outputdir")
        if cf.has_option("Bonsai","randomseed"):
            random.seed(long(cf.get("Bonsai","randomseed")))
        #Lets generate the random seeds for all the datasets
        seeds = [[random.randint(0,2147483647) for y in xrange(2)] for x in xrange(dataset)]
        
        print fname
        fd = file(os.path.join(outputdir,"%s.dat"%fname),"w")
        r = eval(cf.get("Bonsai","range"))
        for mod,modarg in zip(self.modlist,self.modargs):
            fd.write(mod.INDEX_NAME)
            if len(modarg) > 0:
                fd.write(str(modarg))
            fd.write(" ")
            print mod.INDEX_NAME,
        print

        fd.write(os.linesep)
        
        for test in eval(cf.get("Bonsai","testlist")):
            fd.write(str(test))
            fd.write(" ")
            indcount = [list() for x in xrange(len(self.modlist))]
            quecount = [list() for x in xrange(len(self.modlist))]
             
            
            for i in xrange(dataset):
                self.metric.generateData(test,seeds[i][0])
                queries = self.metric.generateRandomObjects(nqueries,seeds[i][1])
                for j,(mod,modarg) in enumerate(zip(self.modlist,self.modargs)):
                    #try:
                        self.metric.reset()
                        mc = mod.INDEX_CLASS(self.metric,*modarg)
                        indcount[j].append(self.metric.getDistCount())
                        self.metric.reset()
                        
                        for query in queries:
                            mc.range_search(query,r)
                            quecount[j].append(self.metric.getDistCount())
                            #print self.metric.getDistCount()
                            self.metric.reset()
                            
                    #except Exception,e:
                    #    raise e
                    #    quecount[i] = "0"
                    #    quecount[i] = "0"
            
            
            for i in xrange(len(self.modlist)):
                #trim lowest and highest
                indcount[i].sort()
                quecount[i].sort()
                print indcount[i],sum(indcount[i]),indextrim,quecount[i],querytrim
                icount = float(sum(indcount[i][indextrim:-indextrim]))/(dataset-(2*indextrim))
                qcount = float(sum(quecount[i][querytrim:-querytrim]))/((dataset*nqueries)-(2*querytrim))
                if pindex:
                    fd.write(str(icount))
                    fd.write(" ")
                print "(",icount,
                if pquery:
                    fd.write(str(qcount))
                    fd.write(" ")
                print ",",qcount,")",    
            fd.write(os.linesep)
            print
            
        fd.close()
        
        fd = file(os.path.join(outputdir,"%s.plot"%fname),"w")
        plotstr = "set style data linespoints" + os.linesep
        plotstr += "plot '%s.dat' using 2:xtic(1) t 1"%fname
        for i in xrange(3,len(self.modlist)+2):
            plotstr += ",'' u %d t %d"%(i,i-1)
        plotstr += os.linesep
        fd.write(plotstr)
        fd.close()
        
        fd = file(os.path.join(outputdir,"%s.ini"%fname),"w")
        cf.write(fd)
        fd.close()
        #Now lets separate the
        #Lets separate the lines
                    
                
if __name__=="__main__":
    import sys
    print sys.argv
    cf = ConfigParser()
    cf.read(sys.argv[1])
    print cf
    bm = Benchmark(cf)
    bm.run()