from bonsai.pivotselector import RandomSelector,BustosSelector
from metrics import Euclidian,Levensthein
from benchmark import Bencher
from bonsai import laesa

#Test with Euclidian
#test 2^i for [5..20]
#10 dimensions, l_2

dims = 20
lp  = 2
size = 100000
numqueries = 50
selectors = [RandomSelector,BustosSelector]

pstart = 20
pend = 40
pint = 1



euc = Euclidian(dims,lp)
queries = euc.generateRandomQueries(numqueries)
euc.generateData(tsize)
bencher = Bencher(threadnum=1)


results = {}
for selector in selectors:
    results[str(selector)] = [0]*((pend-pstart)/pint)

pos = 0
for numpivot in xrange(pstart,pend,pint):
    modules = [(laesa,{'pivotsel':selector,'rows':numpivot}) for selector in selectors]

    for module in modules:
        name = str(module[1]['pivotsel'])
        bencher.add_range_search(results[name],pos,euc,module,0.4,queries)
    pos += 1
bencher.start()
print results

